<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * Abook is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_abook'.DS.'helpers'.DS.'route.php');

class modAbookAllinoneHelper
{
        function getList(&$params)
        {
                global $mainframe;

                $db                     =& JFactory::getDBO();
                $user           =& JFactory::getUser();
                $userId         = (int) $user->get('id');
		$sort		=(int) $params->get('sort', 0);
                $catid          = trim($params->get('catid', 0));
		$itemid         =(int) $params->get('itemid', '');
                $count          = (int) $params->get('count', 5);
		$show_image     = (int) $params->get('show_image', 1);
                $position       = (int) $params->get('position', 1);
		$desc_length	= (int) $params->get('desc_length', 50);
		$title_length    = (int) $params->get('title_length', 20);
                $aid            = $user->get('aid', 0);

		$temp                           = JRequest::getString('id');
                $temp                           = explode(':', $temp);
                $idbook                                     = $temp[0];

		if ($catid) {
                        $ids = explode( ',', $catid );
                        JArrayHelper::toInteger( $ids );
                        $catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
                }else{
			$catCondition = '';
		}

                $query = "SELECT a.*, cc.name AS catname, GROUP_CONCAT(bb.name ORDER BY bb.name ASC SEPARATOR ', ') AS author,";
		$query .= ($sort==1)?' ROUND( r.rating_sum / r.rating_count ) AS rating, ':'';
                $query .=' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
                        ' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
                        ' FROM #__abbook AS a' .
                        ' INNER JOIN #__abcategories AS cc ON cc.id = a.catid' .
			' LEFT JOIN #__abbookauth AS aa ON aa.idbook = a.id '.
                        ' LEFT JOIN #__abauthor AS bb ON bb.id=aa.idauth ';
		$query .= ($sort==1)?' INNER JOIN #__abrating AS r ON r.book_id = a.id':'';
                $query .=' WHERE a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid.
                        ' AND cc.published = 1' .
			' AND a.published = 1 ';
		$query .=($sort==4)?' AND a.id != '.(int) $idbook:'';
		$query .=$catCondition;
		switch ($sort){
			case 0:
				$query_order =' ORDER BY a.dateinsert DESC';
			break;
			case 1:
                                $query_order =' ORDER BY rating DESC';
                        break;
			case 2:
                                $query_order =' ORDER BY a.hits DESC';
                        break;
			case 3:
                                $query_order =' ORDER BY RAND()';
                        break;
			case 4:
				$option                         = JRequest::getCmd('option');
                                $view                           = JRequest::getCmd('view');

                                if ($option == 'com_abook' && $view == 'book' && $idbook){
                                	$query1 = 'SELECT metakey' .
	                                ' FROM #__abbook' .
        	                        ' WHERE id = '.(int) $idbook;
                	                $db->setQuery($query1);
                        	        if ($metakey = trim($db->loadResult())){
                                		// explode the meta keys on a comma
		                                $keys = explode(',', $metakey);
        		                        $likes = array();
                		                foreach ($keys as $key){
                        		                $key = trim($key);
                                		        if ($key) {
                                        		        // surround with commas so first and last items have surrounding commas
                                                		$likes[] = ',' . $db->getEscaped($key) . ',';
		                                        }
        		                        }
                		                if (count($likes)){
                        		                $query.=' AND ( CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%'.implode('%" OR CONCAT(",", REPLACE(a.metakey,", ",","),",") LIKE "%', $likes).'%" )';
                                		        $query_order=' ORDER BY RAND()';
	                                	}else{
        	                                	$related = array();
                	                        	return $related;
                        	        	}
					}else{
					$related = array();
                                        return $related;
					}
				} else {
                                       	$related = array();
	                                return $related;
				}
                        break;
		}

		$query_group=' GROUP BY a.id ';
		$query=$query.$query_group.$query_order;
                $db->setQuery($query, 0, $count);
                $rows = $db->loadObjectList();
		$params = &JComponentHelper::getParams( 'com_abook' );

                $i              = 0;
                $lists  = array();
                foreach ( $rows as $row )
                {
                        if($row->access <= $aid)
                        {
				if ($show_image==1){
                                        $cover=$row->image!=''?$path_image='images'.DS.$params->get( 'img_path' ).DS.$row->image:'components/com_abook/images/nocover.png';
                                        $lists[$i]->image=$cover;
                                }
				if ($itemid!=''){
                                	$lists[$i]->link = JRoute::_('index.php?option=com_abook&view=book&id='.$row->slug.'&catid='.$row->catslug.'&Itemid='.$itemid);
                                }else{
                                        $lists[$i]->link = JRoute::_(AbookHelperRoute::getBookRoute($row->slug, $row->catslug));
                                }
                        } else {
                                $lists[$i]->link = JRoute::_('index.php?option=com_user&view=login');
                        }
                        	$lists[$i]->author=$row->author;
			$lists[$i]->catlink = JRoute::_(AbookHelperRoute::getCategoryRoute($row->catslug));
                        $lists[$i]->catname = $row->catname;
                        $lists[$i]->title = (strlen($row->title)>$title_length)?substr_replace(htmlspecialchars( $row->title ),"...",$title_length):$row->title;
			$row->html=strip_tags($row->html);
			$lists[$i]->text = (strlen($row->html)>$desc_length)?substr_replace($row->html,"...",$desc_length):$row->html;
                        $i++;
                }

                return $lists;
        }
}
